#ifndef ___xp3ext_h
#define ___xp3ext_h

#define XP3EXT_VERSION "0.02"
#define XP3EXT_DATE    "2010/03/22"

#define XP3MAGIC {0x58,0x50,0x33,0x0d,0x0a,0x20,0x0a,0x1a,0x8b,0x67,0x01}
#define XP3MAGICSIZ 11
#define CUSHIONIDX  0x17

//ǉF

#include <string>
#include <windows.h>
#include <commctrl.h>

//VC2008ȑO͎gȂi炵ĵŎOŒ`
typedef INT8 int8_t;
typedef INT16 int16_t;
typedef INT32 int32_t;
typedef INT64 int64_t;
typedef UINT8 uint8_t;
typedef UINT16 uint16_t;
typedef UINT32 uint32_t;
typedef UINT64 uint64_t;

//GUIˑ̕

int extract_xp3(char* name);
int initialize_xp3(char* name,HWND hList);
void extract_a_file(int num);
int extract_selected_file(char* name,HWND hList);

extern HWND g_hEdit;
extern char* g_path;

static void LOGPRINT(char* text) {
	std::string s = text;
	s += "\r\n";
	int ndx = GetWindowTextLength (g_hEdit);
	//SetFocus (g_hEdit);
	SendMessage (g_hEdit, EM_SETSEL, (WPARAM)ndx, (LPARAM)ndx);
	SendMessage (g_hEdit, EM_REPLACESEL, 0, (LPARAM) ((LPSTR)s.data()));
}

inline BOOL lvAddSubItem(HWND hwnd,char* name,int width,int id){
	LV_COLUMN lvcol;

	lvcol.mask		= LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt		= LVCFMT_LEFT;
	lvcol.cx		= width;
	lvcol.pszText	= name;
	lvcol.iSubItem	= id;
	
	return ListView_InsertColumn(hwnd,id,&lvcol);
}

inline BOOL lvSetItem(HWND hwnd,char* name,int line,int column){
    LV_ITEM item;
	item.mask		= LVIF_TEXT;
	item.pszText	= name;
	item.iItem		= line;
	item.iSubItem	= column;

	return ListView_SetItem(hwnd, &item);
}

inline BOOL lvAddItem(HWND hwnd,char* name,int line){
    LV_ITEM item;
	item.mask		= LVIF_TEXT | LVIF_STATE;
	item.state		= LVIS_SELECTED;
	item.stateMask	= LVIS_SELECTED;
	item.pszText	= name;
	item.iItem		= line;
	item.iSubItem	= 0;

	return ListView_InsertItem(hwnd, &item);
}

inline void lvDeleteSelected(HWND hwnd){
	int count = -1;

	do{
		int id = ListView_GetNextItem(hwnd,count,LVNI_ALL | LVNI_SELECTED);
		if ( id != -1 )
			ListView_DeleteItem(hwnd,id);
		count = id;
	}	while(count !=-1);
}

//

struct xp3head {
  int8_t  magic[XP3MAGICSIZ];
  int64_t cushion_idx;         //  17 00 00 00 00 00 00 00 Œ
  int32_t minor_version;       // gg 2.30  01 00 00 00
  int8_t  cushion_head;        //  0x80 Œ
  int64_t cushion_idx_siz;     //  00 00 00 00 00 00 00 00 Œ
  int64_t fileinfo_idx;
};

// t@CǗwb_
struct xp3filehead {
  int8_t  flag;                // ktO 0=Ǘ񈳏kA1=Ǘk
  int64_t datsiz;              // kǗTCY(񈳏k̏ꍇ݂͑)
  int64_t orgsiz;              // ۂ̊ǗTCY
};

// t@CǗ̃ZOg\
struct xp3segment {
  int32_t flag;                 // 0 = 񈳏kA1 = k
  int64_t offset;               // ̃ZOgf[^xp3t@Cł̈ʒu
  int64_t orgsiz;               // f[^̌(WJ)TCY
  int64_t datsiz;               // xp3t@C(k)f[^TCY
};
#define SEGMENTSIZ (4+8+8+8)  // sizeof(xp3segment)łȂŔcˁH

// t@CǗ̃t@Cinfo\
struct xp3fileinfo {
  int8_t            fileid[4];  // "File"Œ
  int64_t           siz;        // ̊Ǘ̃TCY
  int8_t            infoid[4];  // "info"Œ
  int64_t           infosiz;    // infoTCY
  int32_t           flag;       // 0=veNgȂ 1<<31=veNg
  int64_t           orgsiz;     // WJ̃t@CTCY
  int64_t           datsiz;     // i[Ăt@CTCY
  int16_t           filenamsiz; // t@C(/2Ă)
  //wchar_t           *filenam;   // t@C(xp3ł̓t@C)
  wchar_t           filenam[MAX_PATH*2];   // t@C(xp3ł̓t@C)
  int8_t            segid[4];   // "segm"Œ
  int64_t           segsiz;     // ZOgTCY=segment*28(byte)
  //struct xp3segment *segary;    // ZOg\̂̔z
  struct xp3segment segary[64];    // ZOg\̂̔z
  int8_t            adlerid[4]; // "adlr"Œ
  int64_t           adlersiz;   // adlerTCY(ʏ4Œ)
  int32_t           adlersum;   // Adler-32 `FbNTl
};
#define FILEID   "File"
#define INFOID   "info"
#define SEGID    "segm"
#define ADLRID   "adlr"

#define is_compressed(fileinfo) ((fileinfo).flag & 1)
#define is_protected(fileinfo) ((fileinfo).flag & (1<<31))

#define CHUNKHEADSIZ 12       // `Nwb_TCY = 4(id) + 8(siz)

// CfbNXɈړ֐BG[`FbNt
inline bool fidx(FILE *fp, long idx) {
  return (fseek(fp, idx, SEEK_SET) != 0);
}
/*
#define fidx(fp, idx) \
{ \
int ret; \
  if ((ret=fseek((fp), (idx), SEEK_SET)) != 0) \
    error_exit("%d fidx(fp,0x%08llx) in %s()\n", ret, (idx), __FUNCTION__); \
}
*/
// f[^ǂݍފ֐BG[`FbNt
inline bool fload(FILE *fp, void* buf, size_t siz) {
  return (fread(buf, siz, 1, fp) != 1);
}
/*
#define fload(fp, buf, siz) \
{ \
  if (fread((buf), (siz), 1, (fp)) != 1) \
    error_exit("fload(fp, buf, %lld(=0x%08llx) in %s()\n", (siz), (siz), __FUNCTION__); \
}
*/
// f[^ފ֐BG[`FbNt
inline bool fsave(FILE *fp, void* buf, size_t siz) {
  return (fwrite(buf, siz, 1, fp) != 1);
}
/*
#define fsave(fp, buf, siz) \
{ \
  if (fwrite((buf), (siz), 1, (fp)) != 1) \
    error_exit("fsave(fp, buf, %lld) in %s()\n", (siz), __FUNCTION__); \
}
*/
// IDǂݍފ֐(4byteI[)BG[`FbNtB
inline bool fstrid(FILE *fp, int8_t* int8p) {
  return (fread(int8p, 4/* = sizeof(int8_t)*/, 1, (fp)) != 1);
}

//#define fstrid(fp, int8p) \
//{ \
//  if (fread(int8p, 4/* = sizeof(int8_t)*/, 1, (fp)) != 1) \
//    error_exit("fstrid(fp, int8p) in %s()\n", __FUNCTION__); \
//}

// 8bitǂݍފ֐BG[`FbNtB
inline bool fint8(FILE *fp, int8_t& int8) {
  return (fread(&(int8), 1/* = sizeof(int8_t)*/, 1, (fp)) != 1);
}

// 8bitǂݍފ֐BG[`FbNtB
//#define fint8(fp, int8) \
//{ \
//  if (fread(&(int8), 1/* = sizeof(int8_t)*/, 1, (fp)) != 1) \
//    error_exit("fint8(fp, int8) in %s()\n", __FUNCTION__); \
//}

// 16bitǂݍފ֐BG[`FbNtBgGfBAOB
inline bool fint16(FILE *fp, int16_t& int16) {
  return (fread(&(int16), 4/* = sizeof(int16_t)*/, 1, (fp)) != 1);
}
//// 16bitǂݍފ֐BG[`FbNtBgGfBAOB
//#define fint16(fp, int16) \
//{ \
//  if (fread(&(int16), 4/* = sizeof(int16_t)*/, 1, (fp)) != 1) \
//   error_exit("fint16(fp, int16) in %s()\n", __FUNCTION__); \
//}

// 32bitǂݍފ֐BG[`FbNtBgGfBAOB
inline bool fint32(FILE *fp, int32_t& int32) {
  return (fread(&(int32), 4/* = sizeof(int32_t)*/, 1, (fp)) != 1);
}
// 32bitǂݍފ֐BG[`FbNtBgGfBAOB
//#define fint32(fp, int32) \
//{ \
//  if (fread(&(int32), 4/* = sizeof(int32_t)*/, 1, (fp)) != 1) \
//    error_exit("fint32(fp, int32) in %s()\n", __FUNCTION__); \
//}

// 64bitǂݍފ֐BG[`FbNtBgGfBAOB
inline bool fint64(FILE *fp, int64_t& int64) {
  return (fread(&(int64), 8/* = sizeof(int64_t)*/, 1, (fp)) != 1);
}
// 64bitǂݍފ֐BG[`FbNtBgGfBAOB
//#define fint64(fp, int64) \
//{ \
//  if (fread(&(int64), 8/* = sizeof(int64_t)*/, 1, (fp)) != 1) \
//    error_exit("fint64(fp, int64) in %s()\n", __FUNCTION__); \
//}

// 當IDǂݍފ֐(4byteI[)
#define mstrid(buf, int8p) (memcpy((int8p), (buf), 4), (buf)+=4)

// 8bitǂݍފ֐Abufi߂ĕԂ
#define mint8(buf, int8)   (((int8)  = *(uint8_t *)(buf)), (buf)++)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint16(buf, int16) (((int16) = *(uint16_t*)(buf)), (buf)+=2)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint32(buf, int32) (((int32) = *(uint32_t*)(buf)), (buf)+=4)

// 16bitǂݍފ֐Abufi߂ĕԂ
#define mint64(buf, int64) (((int64) = *(uint64_t*)(buf)), (buf)+=8)

#endif // ___xp3ext_h
